%define pgpver 0.15.3

Summary: A commonly used, MIME compliant mail and news reader.
Name: pine
Version: 4.33
Release: 9k
Copyright: Freely Distributable
Url: http://www.washington.edu/pine/
Group: Applications/Internet
Source0: pine%{version}.tar.bz2
Source1: http://www.megaloman.com/~hany/_data/pinepgp/pinepgp-%{pgpver}.tar.bz2
Source2: pine.conf
Source3: pine-spellcheck
Source5: flock.c
Source6: pine.conf.fixed

# FIXME: Make sure pine-4.30-redhat.patch is up to date
Patch0: pine-4.30-redhat.patch

Patch2: pine4.04-noflock.patch
Patch3: pine-4.21-passwd.patch
Patch4: pine-4.21-fixhome.patch
Patch6: pine-4.30-krb5.patch
Patch8: imap-4.7c2-flock.patch 
Patch9: pine-4.30-ldap.patch
Patch14: pine-4.30-boguswarning.patch

Patch20: pine-4.31-openssl.patch
Patch21: pine-4.31-segfix.patch
Patch22: pine-4.31-lockfile-perm.patch

Patch30: pine-4.33-keymenu.patch
Patch31: pinepgp-0.15.3-pineconf-parse-cleanup.patch
Patch32: imap-2000-time.patch

Patch40: pine4.20-pico-euc.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildPrereq: perl, /lib/libpam.so


%{!?nossl:BuildPrereq: openssl-devel}
%{!?noldap:BuildPrereq: openldap-devel}
%{!?nokerberos:BuildPrereq: krb5-devel}
%{!?nokerberos:Requires: krb5-libs}

%description
Pine is a very popular, easy to use, full-featured email user agent
which includes a simple text editor called pico. Pine supports MIME
extensions and can also be used to read news.  Pine also supports
IMAP, mail and MH style folders.

Pine should be installed because Pine is a very commonly used email
user agent.

%prep

%setup -q -n pine%{version} -a 1

%patch0 -p1 
%patch2 -p1
%{!?nokerberos:%patch6 -p1 }
%patch4 -p1

# imap flock patch
%patch8 -p0
cp %{SOURCE5} imap/src/osdep/unix

%patch3  -p1
%{?!noldap:%patch9 -p1 }
%patch14 -p1

%{!?nossl:%patch20 -p1 }
%patch21 -p1
%patch22 -p1

%patch30 -p1
%patch31 -p1
%patch32 -p1

%patch40 -p1

# this wants /usr/local/bin/perl
chmod 644 contrib/utils/pwd2pine
perl -pi -e "s|/usr/local/bin/perl|/usr/bin/perl|" contrib/utils/pwd2pine

%{?!nokerberos: rm -f krb5 && ln -s /usr/kerberos krb5}
%{?!nokerberos: ./contrib/krb5-setup lnp lnp}

%{?!noldap:rm -fr ldap && mkdir ldap && ln -s /usr/lib ldap/libraries && ln -s /usr/include ldap/include}
%{?!noldap:./contrib/ldap-setup lnp lnp || true}

find -name "*.orig" -or -name "*~"|xargs rm


%build
# Patch Makefile compiler optimization flags
#perl -pi -e "s/BASECFLAGS=.*$/BASECFLAGS=\"$RPM_OPT_FLAGS\"/" \
#	imap/src/osdep/unix/Makefile

# Main build script
./build \
	DEBUG="" \
%ifarch ia64
	OPTIMIZE="-O" \
%else 
	OPTIMIZE="$RPM_OPT_FLAGS" \
%endif
	EXTRACFLAGS="-DIGNORE_LOCK_EACCES_ERRORS" \
%{!?nokerberos:EXTRAAUTHENTICATORS=gss} \
%{!?nossl:SPECIALAUTHENTICATORS=ssl} \
	lnp

cd pinepgp-%{pgpver}
./configure --prefix=/usr --with-gpg=/usr/bin/gpg
make

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/%{_mandir}/man1
mkdir -p $RPM_BUILD_ROOT/usr/doc $RPM_BUILD_ROOT/usr/lib

#We don't want PINE's mime.types, use the one in /etc instead
#install -c -m 644 doc/mime.types $RPM_BUILD_ROOT/usr/lib/mime.types

for n in pine pico pilot; do
    install -c -m 755 -s bin/$n $RPM_BUILD_ROOT/usr/bin/$n
done

# FIXME: Switch the above to this after testing.
#install -m 755 bin/{pine,pico,pilot} $RPM_BUILD_ROOT/usr/bin/

### PINEPGP DROPIN ###
cd pinepgp-%{pgpver}
make install-gpg prefix=$RPM_BUILD_ROOT/usr DESTDIR=$RPM_BUILD_ROOT/usr
install -m755 pinepgpgpg-install $RPM_BUILD_ROOT/usr/bin/pinegpg-install
cd ..
######################

cd doc
for n in pine.1 pico.1 pilot.1; do
    install -m 644 $n $RPM_BUILD_ROOT/%{_mandir}/man1
done

mkdir -p $RPM_BUILD_ROOT/etc
install -m644 %{SOURCE2} $RPM_BUILD_ROOT/etc/pine.conf
install -m644 %{SOURCE6} $RPM_BUILD_ROOT/etc/pine.conf.fixed
install -m755 %{SOURCE3} $RPM_BUILD_ROOT/usr/bin

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc README CPYRIGHT doc/*.txt doc/pine-ports doc/tech-notes doc/mailcap.unx imap/docs/bugs.txt
/usr/bin/pine
/usr/bin/pine-spellcheck
/usr/bin/pico
/usr/bin/pilot

%attr(0755, root, root) %{_prefix}/bin/pinegpg-install
%attr(0755, root, root) %{_prefix}/bin/pinegpg
%attr(0755, root, root) %{_prefix}/bin/gpg-sign
%attr(0755, root, root) %{_prefix}/bin/gpg-sign+encrypt
%attr(0755, root, root) %{_prefix}/bin/gpg-encrypt
%attr(0755, root, root) %{_prefix}/bin/gpg-check

%{_mandir}/man1/pico.1*
%{_mandir}/man1/pine.1*
%{_mandir}/man1/pilot.1*
%attr(0644,root,root)	%config /etc/pine.conf
%attr(0644,root,root)	%config /etc/pine.conf.fixed

%changelog
* Thu May 31 2001 David Joo <djoo@redhat.com>
- Pico-euc Patch has been added
- pine.conf has been edited

* Fri Mar 16 2001 Nalin Dahyabhai <nalin@redhat.com>
- rebuild in new environment

* Thu Mar  8 2001 Mike A. Harris <mharris@redhat.com> 4.33-6
- Changed BuildPreReq of pam-devel to /lib/libpam.so, so it will build
  on Red Hat Linux 7.0 without getting nabbed on a dependancy.
- AHHH!  Fixed default color from black on cyan to white on black
  
* Fri Mar  2 2001 Nalin Dahyabhai <nalin@redhat.com>
- rebuild in new environment

* Sun Feb 25 2001 Mike A. Harris <mharris@redhat.com>
- Added pam-devel as a BuildPreReq (#29426)

* Fri Feb 23 2001 Mike A. Harris <mharris@redhat.com>
- Removed color from default configuration (white on blue)

* Wed Feb 14 2001 Bill Nottingham <notting@redhat.com>
- fix build with current glibc (need both <time.h> and <sys/time.h>)

* Wed Feb 14 2001 Mike A. Harris <mharris@redhat.com>
- Disabled default configuration of gpg filters due to user security concerns
- Various default configuration enhancements

* Sat Feb 10 2001 Mike A. Harris <mharris@redhat.com>
- Added pine-4.33-keymenu.patch to fix glitch with "O" command
- Added pinepgp-0.15.3-pineconf-parse-cleanup.patch to fix a potential
  issue with pinegpg-install (Tim Waugh)

* Wed Feb 07 2001 Mike A. Harris <mharris@redhat.com>
- (#26462) Fixed pine.conf glitch with gpg and multiple recipients
- pinegpg-install didn't get installed, fixed
- Fixed pine.conf to properly call pine-spellcheck

* Tue Feb 06 2001 Mike A. Harris <mharris@redhat.com>
- Added a new spell checker wrapper script, so that one configuration works
  for all Red Hat Linux releases.  (pine-spellcheck)
- Added some files that were missing from pinepgp
- Release bumped to 4.33-1 and built.

* Mon Feb 05 2001 Mike A. Harris <mharris@redhat.com>
- Another friendly neighborhood PINE update to 4.33
	- NNTP auth causes crash
	- Attachment viewing broken
	- Display/URL viewers with quoted args broken
	- Reverse sort doesn't work correctly with filters
	- Some combos of non-ascii chars in subject causes crash
- Removed debugging flag and fixed up the CFLAGS line in 
  imap/src/osdep/unix/Makefile which caused the imap lock patch to fail
- Updated pinepgp to version 0.15.3 which includes some fixes and new
  features like allowing encryption to multiple recipients, and to self,
  etc...

* Fri Jan 19 2001 Mike A. Harris <mharris@redhat.com>
- Updated to newly released PINE 4.32 which fixes:
	- Postponing loses second reply-to address
	- Obscure crash when sorting by Threads
	- Temporary file vulnerabilities
	- Crash when NNTP authentication aborted
	- Make /secure work again (broken in 4.30)
	- Setup printer list problems with $PRINTER
	- Recognize Re[arbitrary stuff]: reply syntax
	- Allow for attaching files on a Windows network drive
- Changed to bzip2 compression for pine and pinepgp tarballs
- Built pine-4.32-1

* Sun Dec 17 2000 Mike A. Harris <mharris@redhat.com>
- Added lockfile-perm patch to remove lockfile permission vulnerability.

* Thu Dec 14 2000 Trond Eivind Glomsrd <teg@redhat.com>
- remove backup files after patching

* Tue Dec 12 2000 Mike A. Harris <mharris@redhat.com>
- Fixed typo in spec for ia64 (%elsevi)
- Changed line of perl that modifies C compiler flags during build.
- Updated openssl and segfix patches to PINE 4.31
- Removed confvar, sparc patches - not needed anymore

* Fri Dec 08 2000 Mike A. Harris <mharris@redhat.com>
- Updated to PINE version 4.31
- Created pine.conf.fixed file to simplify spec file, and changed 
  incorrect comment pointing users to a nonexistant file /usr/lib/pine.conf
- Removed pine-4.02-filter.patch as it is included in 4.31.

* Mon Nov 06 2000 Trond Eivind Glomsrd <teg@redhat.com>
- don't include /usr/lib/mime.types , the one in /etc 
  should be sufficient (#20163)

* Tue Oct 31 2000 Trond Eivind Glomsrd <teg@redhat.com>
- turn off confusing/stupid message about mail directory
  permissions (no, they shouldn't be 1777)

* Mon Oct 30 2000 Trond Eivind Glomsrd <teg@redhat.com>
- add patch to fix proper initialization of configured 
  variables (source: pine mailing list)
- set rsh-open-timeout to 0 (RFE #17577)
- fix a segfault by watching for NULLs 
- add proper initialiazation of pine, as we don't have DEBUG
  enabled (fix from the pine mailing list) - integrate with
  above patch
- add workaround for compiler issue on sparc (from Nalin's 
  imap package) 
- don't include the contrib directory
- include the bugs.txt file, so the "we don't like self-signed 
  certificates"-approach is documented
- build lnp instead of slx

* Fri Oct 27 2000 Trond Eivind Glomsrd <teg@redhat.com>
- 4.30, which should fix the DOS from mailicious headers
- redo a lot of patches
- remove old, now obsolete patches

* Mon Sep 25 2000 Trond Eivind Glomsrd <teg@redhat.com>
- patch to fix header vulnerability from 
  Leena Heino <liinu@uta.fi>
- implemented a nossl option

* Fri Sep 08 2000 Nalin Dahyabhai <nalin@redhat.com>
- link against libldap dynamically

* Thu Sep 07 2000 Trond Eivind Glomsrd <teg@redhat.com>
- use /usr/bin/perl instead of /usr/bin/local/perl for
  a supplied script in the documentation
- use /usr/bin/passwd for password changes (#17328)

* Thu Aug 24 2000 Nalin Dahyabhai <nalin@redhat.com>
- use flock()-over-fcntl() locking emulation (#15779)

* Wed Aug 23 2000 Nalin Dahyabhai <nalin@redhat.com>
- enable SSL via simap

* Mon Jul 19 2000 Trond Eivind Glomsrd <teg@redhat.com>
- don't map ctrl-d to delete, as it currently makes
  backspace work like delete

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Tue Jun 27 2000 Nalin Dahyabhai <nalin@redhat.com>
- Rebuild in new environment (release 19)

* Mon Jun 19 2000 Trond Eivind Glomsrd <teg@redhat.com>
- Use aspell by default

* Wed Jun 14 2000 Trond Eivind Glomsrd <teg@redhat.com>
- New patch to make it compile with new glibc.

* Thu Jun 08 2000 Trond Eivind Glomsrd <teg@redhat.com>
- remove applnk entry
- use %%{_mandir} and %%{_tmppath}

* Wed May 10 2000 Nalin Dahyabhai <nalin@redhat.com>
- reverse sense of enabling kerberos support
- make ldap support optional, though it's built statically

* Fri May  5 2000 Bill Nottingham <notting@redhat.com>
- work around a compiler bug on ia64

* Thu May 04 2000 Trond Eivind Glomsrd <teg@redhat.com>
- enable the 8-bit options by default (esmtp and nntp)
- use ISO-8859-1 as default character set instead of
  US-ASCII
- map delete to ctrl-d

* Thu Apr 27 2000 Trond Eivind Glomsrd <teg@redhat.com>
- update pinepgp to 0.13.1
- don't apply the maildir patches, as they can make pine
  crash if it finds recusive symlinks (bug #9736)

* Tue Apr 18 2000 Trond Eivind Glomsrd <teg@redhat.com>
- remove bogus entry from pine.conf

* Tue Apr  4 2000 Bill Nottingham <notting@redhat.com>
- eliminate explicit krb5-configs dependency

* Fri Mar 24 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- rebuild with current ncurses
- add gnupg support

* Tue Mar 07 2000 Preston Brown <pbrown@redhat.com>
- fix home key in pico/pine

* Wed Mar  1 2000 Nalin Dahyabhai <nalin@redhat.com>
- make kerberos support conditional at build-time
- remove build prereq krb5-devel

* Wed Mar  1 2000 Bill Nottingham <notting@redhat.com>
- integrate kerberos support into main tree

* Fri Feb 23 2000 Nalin Dahyabhai <nalin@redhat.com>
- add GSS authenticator
- BuildPrereq: krb5-devel

* Thu Feb 17 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Fix up maildir patch (Bug #6002)
- BuildPrereq: openldap-devel

* Thu Feb 10 2000 Nalin Dahyabhai <nalin@redhat.com>
- rebuild

* Mon Feb 07 2000 Preston Brown <pbrown@redhat.com>
- wmconfig -> desktop

* Wed Feb 02 2000 Cristian Gafton <gafton@redhat.com>
- fix description
- man pages are compressed

* Fri Jan 21 2000 Preston Brown <pbrown@redhat.com>
- remove enable mouse in xterm config setting.

* Wed Nov 24 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- 4.21
- remove ioctl patch, it's no longer necessary

* Tue Nov  2 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- Provide a more reasonable /etc/pine.conf, allowing stuff like
  tab completion, full header command, ...
- handle RPM_OPT_FLAGS

* Wed Oct 13 1999 Preston Brown <pbrown@redhat.com>
- pine 4.20, updated glibc and maildir patches

* Thu Aug 12 1999 Cristian Gafton <gafton@redhat.com>
- add maildir patch

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 2)

* Fri Feb 26 1999 Cristian Gafton <gafton@redhat.com>
- fix buildroot and add cleanup section
- move config files to /etc/pine.conf

* Tue Feb 02 1999 Preston Brown <pbrown@redhat.com>
- turned off .pine-debugX files

* Thu Dec 17 1998 Cristian Gafton <gafton@redhat.com>
- build against glibc 2.1

* Fri Nov 13 1998 Cristian Gafton <gafton@redhat.com>
- patch to enable SIGWINCH processing (why do the pine folks keep 
  disabling this stuff?!)

* Fri Oct 09 1998 Cristian Gafton <gafton@redhat.com>
- use termios instead of termio (patch used to be in here...)
- use terminfo instead of termcap and link against ncurses instead of termcap
- supply -lcrypt as a standard lib

* Sat Sep 19 1998 Jeff Johnson <jbj@redhat.com>
- upgrade to 4.04 (compatibility with some client imaps).

* Fri Sep 11 1998 Jeff Johnson <jbj@redhat.com>
- use only fcntl locking.

* Thu Sep 10 1998 Jeff Johnson <jbj@redhat.com>
- update to 4.03

* Fri Aug 14 1998 Jeff Johnson <jbj@redhat.com>
- patch to 4.02A.
- disable stupid EACCESS warnings.

* Wed Jul 22 1998 Jeff Johnson <jbj@redhat.com>
- update to 4.02.

* Mon Apr 27 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Thu Jan 15 1998 Erik Troan <ewt@redhat.com>
- added patch to fix pine filters

* Tue Dec 30 1997 Erik Troan <ewt@redhat.com>
- fixed resizing in pine and pico

* Thu Dec 18 1997 Erik Troan <ewt@redhat.com>
- removed patch for SIGCHLD race -- it shouldn't be necessary
- added patch to avoid longjmp() from SIGCHLD handler -- SIGCHLD handling
  is sane now

* Thu Dec 11 1997 Cristian Gafton <gafton@redhat.com>
- added a patch for handling a SIGCHLD race condition

* Tue Nov 04 1997 Erik Troan <ewt@redhat.com>
- fix for locks w/ long st_dev field
- use termios rather then termio

* Wed Oct 29 1997 Donnie Barnes <djb@redhat.com>
- added wmconfig entry

* Fri Oct 10 1997 Erik Troan <ewt@redhat.com>
- removed exec bit from /usr/doc/pine-3.96-1/contrib/utils/pwd2pine
